import kivy
from peri import PeriBoard
from kivy.app import App
from kivy.uix.widget import Widget
from kivy.properties import ListProperty, NumericProperty, ReferenceListProperty,\
    ObjectProperty,StringProperty
from kivy.vector import Vector
from kivy.clock import Clock
from random import randint
from random import sample
from kivy.graphics import Color
from kivy.core.window import Window
from kivy.uix.widget import Widget
from kivy.uix.image import Image
kivy.require('1.1.1')
import math
from kivy.uix.floatlayout import FloatLayout
from kivy.uix.gridlayout import GridLayout
from kivy.core.audio import SoundLoader
from kivy.uix.screenmanager import ScreenManager, Screen, FadeTransition
from kivy.lang import Builder
import sys

class PongGame(Widget):
    end = 200;
    tmp = 0;
    tmp2 = 0;
    peri = PeriBoard()
    start = 0;
    count = 50;
    count2 = 50;
    count_ball = [100,100,100,100,100];
    ball = ObjectProperty(None)
    ball2 = ObjectProperty(None)
    ball3 = ObjectProperty(None)
    ball4 = ObjectProperty(None)
    ball5 = ObjectProperty(None)
    player1 = ObjectProperty(None)
    player2 = ObjectProperty(None)

    music = SoundLoader.load('music.wav')

    m_width = 800
    m_height = 600

    def random_pos(self):
        x = sample([self.m_width/10,self.m_width-(self.m_width/10)],1)
        y = sample([self.m_height/10,self.m_height-(self.m_height/10)],1)
        if x[0] == self.m_width/10:
            if y[0] == self.m_height/10:
                zeta = sample([35,40,50,55],1)
            elif y[0] == self.m_height-(self.m_height/10):
                zeta = sample([305,310,320,325],1)
        elif x[0] == self.m_width-self.m_width/10:
            if y[0] == self.m_height/10:
                zeta = sample([125,130,140,145],1)
            elif y[0] == self.m_height-(self.m_height/10):
                zeta = sample([215,220,230,235],1)
        coordinate =  [ x[0],y[0],zeta[0] ]
        return coordinate

    def serve_ball(self,typ):
        speed = 9
        if typ == "all" : 
            self.music.play()
            self.start = 1
            self.ball.center = [ 400,250 ]
            self.ball2.center = [ 350,300 ]
            self.ball3.center = [ 450,300 ]
            self.ball4.center = [ 380,350 ]
            self.ball5.center = [ 420,350 ]
            self.count_ball[0] = 5;
            
        elif typ == "1" :
            randompos = self.random_pos()
            self.ball.center = [ randompos[0] , randompos[1] ]
            self.ball.velocity = Vector(speed, 0).rotate(randompos[2])
            self.count_ball[0] = 100;
            if self.start == 1:
                self.count_ball[1] = 5;
        elif typ == "2" :
            randompos = self.random_pos()
            self.ball2.center = [ randompos[0] , randompos[1] ]
            self.ball2.velocity = Vector(speed, 0).rotate(randompos[2])
            self.count_ball[1] = 100;
            if self.start == 1:
                self.count_ball[2] = 5;
        elif typ == "3" : 
            randompos = self.random_pos()
            self.ball3.center = [ randompos[0] , randompos[1] ]
            self.ball3.velocity = Vector(speed, 0).rotate(randompos[2])
            self.count_ball[2] = 100;
            if self.start == 1:
                self.count_ball[3] = 5;
        elif typ == "4" :
            randompos = self.random_pos()
            self.ball4.center = [ randompos[0] , randompos[1] ]
            self.ball4.velocity = Vector(speed, 0).rotate(randompos[2])
            self.count_ball[3] = 100;
            if self.start == 1:
                self.count_ball[4] = 5;
        elif typ == "5" :      
            randompos = self.random_pos()
            self.ball5.center = [ randompos[0] , randompos[1] ]
            self.ball5.velocity = Vector(speed, 0).rotate(randompos[2])
            self.count_ball[4] = 100;
            if self.start == 1:
                self.start = 0

    def update(self,dt):
        
        ##move p1##
        position = 0.95*self.tmp
        position += 0.05*(self.peri.getAc())
        self.tmp = position
        self.player1.center_y = position-140
        ##move p2##
        position2 = 0.90*self.tmp2
        position2 -= 0.10*(self.peri.getAc2())
        self.tmp2 = position2
        self.player2.center_y = position2+1500
        ##
        
        ##button1##
        if(self.peri.getSwitch() is True and self.count == 0 ):
            if self.ball.center[0]<self.player1.center[0]+125 and self.ball.center[1]<self.player1.center[1]+100 and self.ball.center[1]>self.player1.center[1]-100:
                self.ball.velocity = Vector(math.fabs(self.ball.velocity[0]) * 2, self.ball.velocity[1])
            if self.ball2.center[0]<self.player1.center[0]+125 and self.ball2.center[1]<self.player1.center[1]+100 and self.ball2.center[1]>self.player1.center[1]-100:
                self.ball2.velocity = Vector(math.fabs(self.ball2.velocity[0]) * 2, self.ball2.velocity[1])
            if self.ball3.center[0]<self.player1.center[0]+125 and self.ball3.center[1]<self.player1.center[1]+100 and self.ball3.center[1]>self.player1.center[1]-100:
                self.ball3.velocity = Vector(math.fabs(self.ball3.velocity[0]) * 2, self.ball3.velocity[1])
            if self.ball4.center[0]<self.player1.center[0]+125 and self.ball4.center[1]<self.player1.center[1]+100 and self.ball4.center[1]>self.player1.center[1]-100:
                self.ball4.velocity = Vector(math.fabs(self.ball4.velocity[0]) * 2, self.ball4.velocity[1])
            if self.ball5.center[0]<self.player1.center[0]+125 and self.ball5.center[1]<self.player1.center[1]+100 and self.ball5.center[1]>self.player1.center[1]-100:
                self.ball5.velocity = Vector(math.fabs(self.ball5.velocity[0]) * 2, self.ball5.velocity[1])
            self.count = 50

        ##button2##
        if(self.peri.getSwitch2() is True and self.count2 == 0 ):
            if self.ball.center[0]>self.player2.center[0]-125 and self.ball.center[1]<self.player2.center[1]+100 and self.ball.center[1]>self.player2.center[1]-100:
                self.ball.velocity = Vector(-math.fabs(self.ball.velocity[0]) * 2, self.ball.velocity[1])
            if self.ball2.center[0]>self.player2.center[0]-125 and self.ball2.center[1]<self.player2.center[1]+100 and self.ball2.center[1]>self.player2.center[1]-100:
                self.ball2.velocity = Vector(-math.fabs(self.ball2.velocity[0]) * 2, self.ball2.velocity[1])
            if self.ball3.center[0]>self.player2.center[0]-125 and self.ball3.center[1]<self.player2.center[1]+100 and self.ball3.center[1]>self.player2.center[1]-100:
                self.ball3.velocity = Vector(-math.fabs(self.ball3.velocity[0]) * 2, self.ball3.velocity[1])
            if self.ball4.center[0]>self.player2.center[0]-125 and self.ball4.center[1]<self.player2.center[1]+100 and self.ball4.center[1]>self.player2.center[1]-100:
                self.ball4.velocity = Vector(-math.fabs(self.ball4.velocity[0]) * 2, self.ball4.velocity[1])
            if self.ball5.center[0]>self.player2.center[0]-125 and self.ball5.center[1]<self.player2.center[1]+100 and self.ball5.center[1]>self.player2.center[1]-100:
                self.ball5.velocity = Vector(-math.fabs(self.ball5.velocity[0]) * 2, self.ball5.velocity[1])
            self.count2 = 50
        ##                

        m_width = self.width
        m_height = self.height

        if self.count > 0 :
            self.count -= 1 
        if self.count2 > 0 :
            self.count2 -= 1
        if self.count_ball[0] > 0 and self.count_ball[0] < 100: 
            self.count_ball[0] -=1
        if self.count_ball[1] > 0 and self.count_ball[1] < 100: 
            self.count_ball[1] -=1
        if self.count_ball[2] > 0 and self.count_ball[2] < 100: 
            self.count_ball[2] -=1
        if self.count_ball[3] > 0 and self.count_ball[3] < 100: 
            self.count_ball[3] -=1
        if self.count_ball[4] > 0 and self.count_ball[4] < 100: 
            self.count_ball[4] -=1

        if self.count_ball[0] == 0:
            self.serve_ball("1")
        if self.count_ball[1] == 0:
            self.serve_ball("2")
        if self.count_ball[2] == 0:
            self.serve_ball("3")
        if self.count_ball[3] == 0:
            self.serve_ball("4")
        if self.count_ball[4] == 0:
            self.serve_ball("5")
        
        self.ball.move()
        self.ball2.move()
        self.ball3.move()
        self.ball4.move()
        self.ball5.move()

        self.ball.bounce_ball(self.ball2,self.ball3,self.ball4,self.ball5)
        self.ball2.bounce_ball(self.ball,self.ball3,self.ball4,self.ball5)
        self.ball3.bounce_ball(self.ball,self.ball2,self.ball4,self.ball5)
        self.ball4.bounce_ball(self.ball,self.ball2,self.ball3,self.ball5)
        self.ball5.bounce_ball(self.ball,self.ball2,self.ball3,self.ball4)

        self.player1.bounce_ball(self.ball)
        self.player2.bounce_ball(self.ball)
        self.player1.bounce_ball(self.ball2)
        self.player2.bounce_ball(self.ball2)
        self.player1.bounce_ball(self.ball3)
        self.player2.bounce_ball(self.ball3)
        self.player1.bounce_ball(self.ball4)
        self.player2.bounce_ball(self.ball4)
        self.player1.bounce_ball(self.ball5)
        self.player2.bounce_ball(self.ball5)

        if(self.ball.y < 0) or (self.ball.top > self.height):
            self.ball.velocity_y *= -1
        if(self.ball.x < 0-30) and self.count_ball[0] == 100:
            self.player1.score = str(int(self.player1.score)-1)
            self.count_ball[0] = 99;
        if(self.ball.right > self.width+30) and self.count_ball[0] == 100:
            self.player2.score = str(int(self.player2.score)-1)
            self.count_ball[0] = 99; 

        if(self.ball2.y < 0) or (self.ball2.top > self.height):
            self.ball2.velocity_y *= -1
        if(self.ball2.x < 0-30) and self.count_ball[1] == 100:
            self.player1.score = str(int(self.player1.score)-1)
            self.count_ball[1] = 99;
        if(self.ball2.right > self.width+30) and self.count_ball[1] == 100:
            self.player2.score = str(int(self.player2.score)-1)
            self.count_ball[1] = 99;

        if(self.ball3.y < 0) or (self.ball3.top > self.height):
            self.ball3.velocity_y *= -1
        if(self.ball3.x < 0-30) and self.count_ball[2] == 100:
            self.player1.score = str(int(self.player1.score)-1)
            self.count_ball[2] = 99;
        if(self.ball3.right > self.width+30 and self.count_ball[2] == 100):
            self.player2.score = str(int(self.player2.score)-1)
            self.count_ball[2] = 99;

        if(self.ball4.y < 0) or (self.ball4.top > self.height):
            self.ball4.velocity_y *= -1
        if(self.ball4.x < 0-30 and self.count_ball[3] == 100):
            self.player1.score = str(int(self.player1.score)-1)
            self.count_ball[3] = 99;
        if(self.ball4.right > self.width+30 and self.count_ball[3] == 100):
            self.player2.score = str(int(self.player2.score)-1)
            self.count_ball[3] = 99; 

        if(self.ball5.y < 0) or (self.ball5.top > self.height):
            self.ball5.velocity_y *= -1
        if(self.ball5.x < 0-30 and self.count_ball[4] == 100):
            self.player1.score = str(int(self.player1.score)-1)
            self.count_ball[4] = 99;
        if(self.ball5.right > self.width+30 and self.count_ball[4] == 100):
            self.player2.score = str(int(self.player2.score)-1)
            self.count_ball[4] = 99;

        if(self.player1.score == "0" or self.player1.score == "-1"):
            self.player1.score = "Lose"
            self.player2.score = "Win"
            self.ball.velocity = Vector(0,0).rotate(0)
            self.ball2.velocity = Vector(0,0).rotate(0)
            self.ball3.velocity = Vector(0,0).rotate(0)
            self.ball4.velocity = Vector(0,0).rotate(0)
            self.ball5.velocity = Vector(0,0).rotate(0)
            self.count_ball[0] = 101;
            self.count_ball[1] = 101;
            self.count_ball[2] = 101;
            self.count_ball[3] = 101;
            self.count_ball[4] = 101; 
            self.end = 199;        

        if(self.player2.score == "0" or self.player2.score == "-1"):
            self.player1.score = "Win"
            self.player2.score = "Lose"
            self.ball.velocity = Vector(0,0).rotate(0)
            self.ball2.velocity = Vector(0,0).rotate(0)
            self.ball3.velocity = Vector(0,0).rotate(0)
            self.ball4.velocity = Vector(0,0).rotate(0)
            self.ball5.velocity = Vector(0,0).rotate(0)
            self.count_ball[0] = 101;
            self.count_ball[1] = 101;
            self.count_ball[2] = 101;
            self.count_ball[3] = 101;
            self.count_ball[4] = 101;
            self.end = 199;

        if self.end <= 0:
            sys.exit()
        if self.end < 200:
            self.end = self.end - 1
    """
    def on_touch_move(self, touch):
        if touch.x < self.width / 3:
            self.player1.center_y = touch.y
        if touch.x > self.width - self.width / 3:
            self.player2.center_y = touch.y 
    """

class GameScreen(Screen):    
    def on_pre_enter(self):
        self.ponggame.serve_ball("all")
        Clock.schedule_interval(self.ponggame.update,1.0/60)
      
class MenuScreen(Screen):
    sound = SoundLoader.load('title.wav')
    def on_pre_enter(self):
        self.sound.play()
    def on_pre_leave(self):
        self.sound.stop()

class ExitScreen(Screen):
    def on_pre_enter(self):
        sys.exit()
        

class PongApp(App):

    def build(self):
        sm = ScreenManager(transition=FadeTransition())
        sm.add_widget(MenuScreen(name='menu'))     
        sm.add_widget(GameScreen(name='Goto'))
        sm.add_widget(ExitScreen(name='exit'))    
        return sm
        #game = PongGame()
        #game.serve_ball("all")
        #Clock.schedule_interval(game.update,1.0/60)
        #return game

"""
class intro(Widget):

    def __init__(self, **kwargs):
        super(intro, self).__init__(**kwargs)
        self._keyboard = Window.request_keyboard(
            self._keyboard_closed, self)
        self._keyboard.bind(on_key_down=self._on_keyboard_down)
    
    def _keyboard_closed(self):
        f('My keyboard have been closed!')
        self._keyboard.unbind(on_key_down=self._on_keyboard_down)
        self._keyboard = None

    def _on_keyboard_down(self, keyboard, keycode, text, modifiers):
        if keycode[1] == 'a':
            game = PongGame()
            game.serve_ball("all")
            Clock.schedule_interval(game.update,1.0/60)
            return game
"""

class PongBall(Widget):

    sound = SoundLoader.load('12913_sweet_trip_mm_kick_hi.wav')

    velocity_x = NumericProperty(0)
    velocity_y = NumericProperty(0)
    #position_x = NumericProperty(0)
    #position_y = NumericProperty(0)

    velocity = ReferenceListProperty(velocity_x,velocity_y)
    #pos = ReferenceListProperty(position_x,position_y)

    def bounce_ball(self,ball2,ball3,ball4,ball5):
        if self.collide_widget(ball2):
            if ball2.y > self.y :
                if ball2.velocity_y < 0 :
                    ball2.velocity_y *= -1
                    self.sound.play()
                else :
                    ball2.velocity_x *= -1
                    self.sound.play()
            else : 
                if ball2.velocity_y > 0 :
                    ball2.velocity_y *= -1
                    self.sound.play()
                else :
                    ball2.velocity_x *= -1
                    self.sound.play()
        if self.collide_widget(ball3):
            if ball3.y > self.y :
                if ball3.velocity_y < 0 :
                    ball3.velocity_y *= -1
                    self.sound.play()
                else :
                    ball3.velocity_x *= -1
                    self.sound.play()
            else : 
                if ball3.velocity_y > 0 :
                    ball3.velocity_y *= -1
                    self.sound.play()
                else :
                    ball3.velocity_x *= -1
                    self.sound.play()
        if self.collide_widget(ball4):
            if ball4.y > self.y :
                if ball4.velocity_y < 0 :
                    ball4.velocity_y *= -1
                    self.sound.play()
                else :
                    ball4.velocity_x *= -1
                    self.sound.play()
            else : 
                if ball4.velocity_y > 0 :
                    ball4.velocity_y *= -1
                    self.sound.play()
                else :
                    ball4.velocity_x *= -1
                    self.sound.play()
        if self.collide_widget(ball5):
            if ball5.y > self.y :
                if ball5.velocity_y < 0 :
                    ball5.velocity_y *= -1
                    self.sound.play()
                else :
                    ball5.velocity_x *= -1
                    self.sound.play()
            else : 
                if ball5.velocity_y > 0 :
                    ball5.velocity_y *= -1
                    self.sound.play()
                else :
                    ball5.velocity_x *= -1
                    self.sound.play()


    def move(self):
        self.pos = Vector(*self.velocity) + self.pos

class PongBall2(Widget):

    sound = SoundLoader.load('12913_sweet_trip_mm_kick_hi.wav')

    velocity_x = NumericProperty(0)
    velocity_y = NumericProperty(0)

    velocity = ReferenceListProperty(velocity_x,velocity_y)

    def bounce_ball(self,ball,ball3,ball4,ball5):
        if self.collide_widget(ball):
            if ball.y > self.y :
                if ball.velocity_y < 0 :
                    ball.velocity_y *= -1
                else :
                    ball.velocity_x *= -1
            else : 
                if ball.velocity_y > 0 :
                    ball.velocity_y *= -1
                else :
                    ball.velocity_x *= -1
        if self.collide_widget(ball3):
            if ball3.y > self.y :
                if ball3.velocity_y < 0 :
                    ball3.velocity_y *= -1
                    self.sound.play()
                else :
                    ball3.velocity_x *= -1
                    self.sound.play()
            else : 
                if ball3.velocity_y > 0 :
                    ball3.velocity_y *= -1
                    self.sound.play()
                else :
                    ball3.velocity_x *= -1
                    self.sound.play()
        if self.collide_widget(ball4):
            if ball4.y > self.y :
                if ball4.velocity_y < 0 :
                    ball4.velocity_y *= -1
                    self.sound.play()
                else :
                    ball4.velocity_x *= -1
                    self.sound.play()
            else : 
                if ball4.velocity_y > 0 :
                    ball4.velocity_y *= -1
                    self.sound.play()
                else :
                    ball4.velocity_x *= -1
                    self.sound.play()
        if self.collide_widget(ball5):
            if ball5.y > self.y :
                if ball5.velocity_y < 0 :
                    ball5.velocity_y *= -1
                    self.sound.play()
                else :
                    ball5.velocity_x *= -1
                    self.sound.play()
            else : 
                if ball5.velocity_y > 0 :
                    ball5.velocity_y *= -1
                    self.sound.play()
                else :
                    ball5.velocity_x *= -1
                    self.sound.play()

    def move(self):
        self.pos = Vector(*self.velocity) + self.pos

class PongBall3(Widget):

    sound = SoundLoader.load('12913_sweet_trip_mm_kick_hi.wav')

    velocity_x = NumericProperty(0)
    velocity_y = NumericProperty(0)

    velocity = ReferenceListProperty(velocity_x,velocity_y)

    def bounce_ball(self,ball,ball2,ball4,ball5):
        if self.collide_widget(ball):
            if ball.y > self.y :
                if ball.velocity_y < 0 :
                    ball.velocity_y *= -1
                else :
                    ball.velocity_x *= -1
            else : 
                if ball.velocity_y > 0 :
                    ball.velocity_y *= -1
                else :
                    ball.velocity_x *= -1
        if self.collide_widget(ball2):
            if ball2.y > self.y :
                if ball2.velocity_y < 0 :
                    ball2.velocity_y *= -1
                else :
                    ball2.velocity_x *= -1
            else : 
                if ball2.velocity_y > 0 :
                    ball2.velocity_y *= -1
                else :
                    ball2.velocity_x *= -1
        if self.collide_widget(ball4):
            if ball4.y > self.y :
                if ball4.velocity_y < 0 :
                    ball4.velocity_y *= -1
                    self.sound.play()
                else :
                    ball4.velocity_x *= -1
                    self.sound.play()
            else : 
                if ball4.velocity_y > 0 :
                    ball4.velocity_y *= -1
                    self.sound.play()
                else :
                    ball4.velocity_x *= -1
                    self.sound.play()
        if self.collide_widget(ball5):
            if ball5.y > self.y :
                if ball5.velocity_y < 0 :
                    ball5.velocity_y *= -1
                    self.sound.play()
                else :
                    ball5.velocity_x *= -1
                    self.sound.play()
            else : 
                if ball5.velocity_y > 0 :
                    ball5.velocity_y *= -1
                    self.sound.play()
                else :
                    ball5.velocity_x *= -1
                    self.sound.play()


    def move(self):
        self.pos = Vector(*self.velocity) + self.pos

class PongBall4(Widget):

    sound = SoundLoader.load('12913_sweet_trip_mm_kick_hi.wav')

    velocity_x = NumericProperty(0)
    velocity_y = NumericProperty(0)

    velocity = ReferenceListProperty(velocity_x,velocity_y)

    def bounce_ball(self,ball,ball2,ball3,ball5):
        if self.collide_widget(ball):
            if ball.y > self.y :
                if ball.velocity_y < 0 :
                    ball.velocity_y *= -1
                else :
                    ball.velocity_x *= -1
            else : 
                if ball.velocity_y > 0 :
                    ball.velocity_y *= -1
                else :
                    ball.velocity_x *= -1
        if self.collide_widget(ball2):
            if ball2.y > self.y :
                if ball2.velocity_y < 0 :
                    ball2.velocity_y *= -1
                else :
                    ball2.velocity_x *= -1
            else : 
                if ball2.velocity_y > 0 :
                    ball2.velocity_y *= -1
                else :
                    ball2.velocity_x *= -1
        if self.collide_widget(ball3):
            if ball3.y > self.y :
                if ball3.velocity_y < 0 :
                    ball3.velocity_y *= -1
                else :
                    ball3.velocity_x *= -1
            else : 
                if ball3.velocity_y > 0 :
                    ball3.velocity_y *= -1
                else :
                    ball3.velocity_x *= -1
        if self.collide_widget(ball5):
            if ball5.y > self.y :
                if ball5.velocity_y < 0 :
                    ball5.velocity_y *= -1
                    self.sound.play()
                else :
                    ball5.velocity_x *= -1
                    self.sound.play()
            else : 
                if ball5.velocity_y > 0 :
                    ball5.velocity_y *= -1
                    self.sound.play()
                else :
                    ball5.velocity_x *= -1
                    self.sound.play()


    def move(self):
        self.pos = Vector(*self.velocity) + self.pos

class PongBall5(Widget):
    velocity_x = NumericProperty(0)
    velocity_y = NumericProperty(0)

    velocity = ReferenceListProperty(velocity_x,velocity_y)

    def bounce_ball(self,ball,ball2,ball3,ball4):
        if self.collide_widget(ball):
            if ball.y > self.y :
                if ball.velocity_y < 0 :
                    ball.velocity_y *= -1
                else :
                    ball.velocity_x *= -1
            else : 
                if ball.velocity_y > 0 :
                    ball.velocity_y *= -1
                else :
                    ball.velocity_x *= -1
        if self.collide_widget(ball2):
            if ball2.y > self.y :
                if ball2.velocity_y < 0 :
                    ball2.velocity_y *= -1
                else :
                    ball2.velocity_x *= -1
            else : 
                if ball2.velocity_y > 0 :
                    ball2.velocity_y *= -1
                else :
                    ball2.velocity_x *= -1
        if self.collide_widget(ball3):
            if ball3.y > self.y :
                if ball3.velocity_y < 0 :
                    ball3.velocity_y *= -1
                else :
                    ball3.velocity_x *= -1
            else : 
                if ball3.velocity_y > 0 :
                    ball3.velocity_y *= -1
                else :
                    ball3.velocity_x *= -1
        if self.collide_widget(ball4):
            if ball4.y > self.y :
                if ball4.velocity_y < 0 :
                    ball4.velocity_y *= -1
                else :
                    ball4.velocity_x *= -1
            else : 
                if ball4.velocity_y > 0 :
                    ball4.velocity_y *= -1
                else :
                    ball4.velocity_x *= -1
 

    def move(self):
        self.pos = Vector(*self.velocity) + self.pos

class Player(Widget):
    score = StringProperty("40")

    def bounce_ball(self, ball):
        if self.collide_widget(ball):
            vx, vy = ball.velocity
            offset = (ball.center_y - self.center_y) / (self.height / 2)
            bounced = Vector(-1 * vx, vy)
            vel = bounced * 1.1
            ball.velocity = vel.x, vel.y + offset

    def mycollise(self, ball):
        vx, vy = ball.velocity
        offset = (ball.center_y - self.center_y) / (self.height / 2)
        bounced = Vector(-1 * vx, vy)
        vel = bounced * 1.1
        ball.velocity = vel.x, vel.y + offset

if __name__ == '__main__':
    PongApp().run()
